package ca.ubc.stat.blang;

import ca.ubc.stat.blang.AbstractBlangDslRuntimeModule;
import ca.ubc.stat.blang.compiler.BlangXbaseCompiler;
import ca.ubc.stat.blang.scoping.BlangImplicitlyImportedFeatures;
import ca.ubc.stat.blang.scoping.ImplicitImportsScopeProvider;
import ca.ubc.stat.blang.typesystem.BlangSynonymTypesProvider;
import com.google.inject.Binder;
import com.google.inject.name.Names;
import org.eclipse.xtext.scoping.IScopeProvider;
import org.eclipse.xtext.scoping.impl.AbstractDeclarativeScopeProvider;
import org.eclipse.xtext.xbase.compiler.XbaseCompiler;
import org.eclipse.xtext.xbase.scoping.batch.ImplicitlyImportedFeatures;
import org.eclipse.xtext.xbase.typesystem.computation.SynonymTypesProvider;

/**
 * Use this class to register components to be used at runtime / without the Equinox extension registry.
 */
@SuppressWarnings("all")
public class BlangDslRuntimeModule extends AbstractBlangDslRuntimeModule {
  public Class<? extends SynonymTypesProvider> bindSynonymTypesProvider() {
    return BlangSynonymTypesProvider.class;
  }
  
  public Class<? extends XbaseCompiler> bindXbaseCompiler() {
    return BlangXbaseCompiler.class;
  }
  
  public Class<? extends ImplicitlyImportedFeatures> bindImplicitlyImportedTypes() {
    return BlangImplicitlyImportedFeatures.class;
  }
  
  @Override
  public void configureIScopeProviderDelegate(final Binder binder) {
    binder.<IScopeProvider>bind(IScopeProvider.class).annotatedWith(Names.named(AbstractDeclarativeScopeProvider.NAMED_DELEGATE)).to(ImplicitImportsScopeProvider.class);
  }
}
