package ca.ubc.stat.blang;

import ca.ubc.stat.blang.blangDsl.BlangModel;
import ca.ubc.stat.blang.blangDsl.Dependency;
import ca.ubc.stat.blang.blangDsl.InitializerDependency;
import ca.ubc.stat.blang.blangDsl.VariableType;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtend2.lib.StringConcatenationClient;
import org.eclipse.xtext.nodemodel.util.NodeModelUtils;
import org.eclipse.xtext.util.Strings;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class StaticUtils {
  private StaticUtils() {
  }
  
  public static String uniqueDeclaredMethod(final Class<?> someClass) {
    final Method[] declaredMethod = someClass.getDeclaredMethods();
    int _size = ((List<Method>)Conversions.doWrapArray(declaredMethod)).size();
    boolean _notEquals = (_size != 1);
    if (_notEquals) {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("Class ");
      _builder.append(someClass);
      _builder.append(" was assumed to have only one method but found ");
      int _size_1 = ((List<Method>)Conversions.doWrapArray(declaredMethod)).size();
      _builder.append(_size_1);
      _builder.newLineIfNotEmpty();
      throw new RuntimeException(_builder.toString());
    }
    return declaredMethod[0].getName();
  }
  
  public static boolean isParam(final VariableType variableType) {
    boolean _switchResult = false;
    if (variableType != null) {
      switch (variableType) {
        case PARAM:
          _switchResult = true;
          break;
        case RANDOM:
          _switchResult = false;
          break;
        default:
          throw new RuntimeException();
      }
    } else {
      throw new RuntimeException();
    }
    return _switchResult;
  }
  
  public static String generatedName(final String uniqueName) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("$generated__");
    _builder.append(uniqueName);
    return _builder.toString();
  }
  
  public static List<InitializerDependency> initializerDependencies(final List<Dependency> dependencies) {
    final List<InitializerDependency> result = new ArrayList<InitializerDependency>();
    for (final Dependency dependency : dependencies) {
      boolean _matched = false;
      if (dependency instanceof InitializerDependency) {
        _matched=true;
        result.add(((InitializerDependency)dependency));
      }
    }
    return result;
  }
  
  public static String expressionText(final EObject ex) {
    return NodeModelUtils.getTokenText(NodeModelUtils.getNode(ex));
  }
  
  public static void eagerlyEvaluate(final StringConcatenationClient lazyString) {
    final StringConcatenation dummy = new StringConcatenation();
    dummy.append(lazyString, "");
  }
  
  public static void setFieldValue(final Field f, final Object instance, final Object value) {
    try {
      boolean isAccessible = f.isAccessible();
      if ((!isAccessible)) {
        f.setAccessible(true);
      }
      f.set(instance, value);
      if ((!isAccessible)) {
        f.setAccessible(false);
      }
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public static String getterName(final String fieldName) {
    String _firstUpper = Strings.toFirstUpper(fieldName);
    return ("get" + _firstUpper);
  }
  
  public static String setterName(final String fieldName) {
    String _firstUpper = Strings.toFirstUpper(fieldName);
    return ("set" + _firstUpper);
  }
  
  public static String fullyQualifiedNameString(final BlangModel model) {
    String _xifexpression = null;
    boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(model.getPackage());
    if (_isNullOrEmpty) {
      _xifexpression = "";
    } else {
      _xifexpression = model.getPackage();
    }
    final String prefix = _xifexpression;
    String _name = model.getName();
    return (prefix + _name);
  }
  
  /**
   * Transforms a blang string into a string that can be
   * inserted into Java code inside an expression of the form
   * String str = "<output string pasted here>";
   */
  public static String escape(final String blangString) {
    return blangString.replace("\\", "\\\\").replace("\"", "\\\"");
  }
}
