package ca.ubc.stat.blang.typesystem;

import ca.ubc.stat.blang.compiler.BlangXbaseCompiler;
import com.google.common.base.Objects;
import java.util.HashMap;
import org.eclipse.xtext.common.types.JvmType;
import org.eclipse.xtext.common.types.util.TypeReferences;
import org.eclipse.xtext.xbase.compiler.Later;
import org.eclipse.xtext.xbase.compiler.output.ITreeAppendable;
import org.eclipse.xtext.xbase.lib.Functions.Function2;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.typesystem.computation.SynonymTypesProvider;
import org.eclipse.xtext.xbase.typesystem.conformance.ConformanceFlags;
import org.eclipse.xtext.xbase.typesystem.references.ITypeReferenceOwner;
import org.eclipse.xtext.xbase.typesystem.references.LightweightTypeReference;
import org.eclipse.xtext.xbase.typesystem.references.ParameterizedTypeReference;

@SuppressWarnings("all")
public class BlangSynonymTypesProvider extends SynonymTypesProvider {
  @Override
  protected boolean collectCustomSynonymTypes(final LightweightTypeReference type, final SynonymTypesProvider.Acceptor acceptor) {
    boolean _xblockexpression = false;
    {
      final HashMap<String, Function2<Later, ITreeAppendable, ITreeAppendable>> synonyms = BlangXbaseCompiler.typeConversionMap.get(type.getIdentifier());
      boolean _notEquals = (!Objects.equal(synonyms, null));
      if (_notEquals) {
        final Function2<Boolean, String, Boolean> _function = (Boolean rc, String synonym) -> {
          return Boolean.valueOf(this.announceModelType(type.getOwner(), synonym, acceptor));
        };
        return (boolean) IterableExtensions.<String, Boolean>fold(synonyms.keySet(), Boolean.valueOf(true), _function);
      }
      _xblockexpression = super.collectCustomSynonymTypes(type, acceptor);
    }
    return _xblockexpression;
  }
  
  protected boolean announceModelType(final ITypeReferenceOwner owner, final String targetName, final SynonymTypesProvider.Acceptor acceptor) {
    boolean _xblockexpression = false;
    {
      final TypeReferences typeRefs = owner.getServices().getTypeReferences();
      final JvmType synonym = typeRefs.findDeclaredType(targetName, owner.getContextResourceSet());
      boolean _xifexpression = false;
      if ((synonym != null)) {
        ParameterizedTypeReference _parameterizedTypeReference = new ParameterizedTypeReference(owner, synonym);
        _xifexpression = this.announceSynonym(_parameterizedTypeReference, 
          ConformanceFlags.DEMAND_CONVERSION, acceptor);
      } else {
        _xifexpression = true;
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
}
